Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsed.F90	(revision 8841)
@@ -54,5 +54,5 @@
       REAL(wp) ::  zwflux, zfminus, zfplus
       REAL(wp) ::  zlim, zfact, zfactcal
-      REAL(wp) ::  zo2, zno3, zflx, zpdenit, z1pdenit, zdenitt, zolimit
+      REAL(wp) ::  zo2, zno3, zflx, zpdenit, z1pdenit, zolimit
       REAL(wp) ::  zsiloss, zcaloss, zws3, zws4, zwsc, zdep
       REAL(wp) ::  zwstpoc, zwstpon, zwstpop
@@ -319,6 +319,6 @@
                tra(ji,jj,ikt,jptal) =  tra(ji,jj,ikt,jptal) + zcaloss * zrivalk * 2.0
                tra(ji,jj,ikt,jpdic) =  tra(ji,jj,ikt,jpdic) + zcaloss * zrivalk
-               zsedcal(ji,jj) = (1.0 - zrivalk) * zcaloss / zdep
-               zsedsi (ji,jj) = (1.0 - zrivsil) * zsiloss / zdep
+               zsedcal(ji,jj) = (1.0 - zrivalk) * zcaloss * e3t_n(ji,jj,ikt) 
+               zsedsi (ji,jj) = (1.0 - zrivsil) * zsiloss * e3t_n(ji,jj,ikt) 
             END DO
          END DO
@@ -365,6 +365,6 @@
 
       IF( .NOT.lk_sed ) THEN
-         ! The 0.5 factor in zpdenit and zdenitt is to avoid negative NO3 concentration after both denitrification
-         ! in the sediments and just above the sediments. Not very clever, but simpliest option.
+         ! The 0.5 factor in zpdenit is to avoid negative NO3 concentration after
+         ! denitrification in the sediments. Not very clever, but simpliest option.
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -378,19 +378,18 @@
                z1pdenit = zwstpoc * zrivno3 - zpdenit
                zolimit = MIN( ( trb(ji,jj,ikt,jpoxy) - rtrn ) / o2ut, z1pdenit * ( 1.- nitrfac(ji,jj,ikt) ) )
-               zdenitt = MIN(  0.5 * ( trb(ji,jj,ikt,jpno3) - rtrn ) / rdenit, z1pdenit * nitrfac(ji,jj,ikt) )
-               tra(ji,jj,ikt,jpdoc) = tra(ji,jj,ikt,jpdoc) + z1pdenit - zolimit - zdenitt
-               tra(ji,jj,ikt,jppo4) = tra(ji,jj,ikt,jppo4) + zpdenit + zolimit + zdenitt
-               tra(ji,jj,ikt,jpnh4) = tra(ji,jj,ikt,jpnh4) + zpdenit + zolimit + zdenitt
-               tra(ji,jj,ikt,jpno3) = tra(ji,jj,ikt,jpno3) - rdenit * (zpdenit + zdenitt)
+               tra(ji,jj,ikt,jpdoc) = tra(ji,jj,ikt,jpdoc) + z1pdenit - zolimit
+               tra(ji,jj,ikt,jppo4) = tra(ji,jj,ikt,jppo4) + zpdenit + zolimit
+               tra(ji,jj,ikt,jpnh4) = tra(ji,jj,ikt,jpnh4) + zpdenit + zolimit
+               tra(ji,jj,ikt,jpno3) = tra(ji,jj,ikt,jpno3) - rdenit * zpdenit
                tra(ji,jj,ikt,jpoxy) = tra(ji,jj,ikt,jpoxy) - zolimit * o2ut
-               tra(ji,jj,ikt,jptal) = tra(ji,jj,ikt,jptal) + rno3 * (zolimit + (1.+rdenit) * (zpdenit + zdenitt) )
-               tra(ji,jj,ikt,jpdic) = tra(ji,jj,ikt,jpdic) + zpdenit + zolimit + zdenitt
+               tra(ji,jj,ikt,jptal) = tra(ji,jj,ikt,jptal) + rno3 * (zolimit + (1.+rdenit) * zpdenit )
+               tra(ji,jj,ikt,jpdic) = tra(ji,jj,ikt,jpdic) + zpdenit + zolimit 
                sdenit(ji,jj) = rdenit * zpdenit * e3t_n(ji,jj,ikt)
-               zsedc(ji,jj)   = (1. - zrivno3) * zwstpoc / zdep
+               zsedc(ji,jj)   = (1. - zrivno3) * zwstpoc * e3t_n(ji,jj,ikt)
                IF( ln_p5z ) THEN
                   zwstpop              = trb(ji,jj,ikt,jpgop) * zws4 + trb(ji,jj,ikt,jppop) * zws3
                   zwstpon              = trb(ji,jj,ikt,jpgon) * zws4 + trb(ji,jj,ikt,jppon) * zws3
-                  tra(ji,jj,ikt,jpdon) = tra(ji,jj,ikt,jpdon) + (z1pdenit - zolimit - zdenitt) * zwstpon / (zwstpoc + rtrn)
-                  tra(ji,jj,ikt,jpdop) = tra(ji,jj,ikt,jpdop) + (z1pdenit - zolimit - zdenitt) * zwstpop / (zwstpoc + rtrn)
+                  tra(ji,jj,ikt,jpdon) = tra(ji,jj,ikt,jpdon) + ( z1pdenit - zolimit ) * zwstpon / (zwstpoc + rtrn)
+                  tra(ji,jj,ikt,jpdop) = tra(ji,jj,ikt,jpdop) + ( z1pdenit - zolimit ) * zwstpop / (zwstpoc + rtrn)
                ENDIF
             END DO
@@ -494,17 +493,17 @@
       IF( lk_iomput ) THEN
          IF( knt == nrdttrc ) THEN
-            zfact = 1.e+3 * rfact2r * rno3  !  conversion from molC/l/kt  to molN/m3/s
-            IF( iom_use("Nfix"   ) ) CALL iom_put( "Nfix", nitrpot(:,:,:) * nitrfix * zfact * tmask(:,:,:) )  ! nitrogen fixation 
+            zfact = 1.e+3 * rfact2r !  conversion from molC/l/kt  to molN/m3/s
+            IF( iom_use("Nfix"   ) ) CALL iom_put( "Nfix", nitrpot(:,:,:) * nitrfix * rno3 * zfact * tmask(:,:,:) )  ! nitrogen fixation 
             IF( iom_use("INTNFIX") ) THEN   ! nitrogen fixation rate in ocean ( vertically integrated )
                zwork1(:,:) = 0.
                DO jk = 1, jpkm1
-                 zwork1(:,:) = zwork1(:,:) + nitrpot(:,:,jk) * nitrfix * zfact * e3t_n(:,:,jk) * tmask(:,:,jk)
+                 zwork1(:,:) = zwork1(:,:) + nitrpot(:,:,jk) * nitrfix * rno3 * zfact * e3t_n(:,:,jk) * tmask(:,:,jk)
                ENDDO
                CALL iom_put( "INTNFIX" , zwork1 ) 
             ENDIF
-            IF( iom_use("SedCal" ) ) CALL iom_put( "SedCal", zsedcal(:,:) * 1.e+3 )
-            IF( iom_use("SedSi" ) )  CALL iom_put( "SedSi",  zsedsi (:,:) * 1.e+3 )
-            IF( iom_use("SedC" ) )   CALL iom_put( "SedC",   zsedc  (:,:) * 1.e+3 )
-            IF( iom_use("Sdenit" ) ) CALL iom_put( "Sdenit", sdenit (:,:) * 1.e+3 * rno3 )
+            IF( iom_use("SedCal" ) ) CALL iom_put( "SedCal", zsedcal(:,:) * zfact )
+            IF( iom_use("SedSi" ) )  CALL iom_put( "SedSi",  zsedsi (:,:) * zfact )
+            IF( iom_use("SedC" ) )   CALL iom_put( "SedC",   zsedc  (:,:) * zfact )
+            IF( iom_use("Sdenit" ) ) CALL iom_put( "Sdenit", sdenit (:,:) * zfact * rno3 )
          ENDIF
       ENDIF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 8841)
@@ -431,11 +431,11 @@
 
       IF( kt == nittrc000 ) THEN 
+         xfact1 = rfact2r * 12. / 1.e15 * ryyss    ! conversion molC/kt --> PgC/yr
+         xfact2 = 1.e+3 * rno3 * 14. / 1.e12 * ryyss   ! conversion molC/l/s ----> TgN/m3/yr
+         xfact3 = 1.e+3 * rfact2r * rno3   ! conversion molC/l/kt ----> molN/m3/s
          IF( ln_check_mass .AND. lwp) THEN      !   Open budget file of NO3, ALK, Si, Fer
             CALL ctl_opn( numco2, 'carbon.budget'  , 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
             CALL ctl_opn( numnut, 'nutrient.budget', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
             CALL ctl_opn( numnit, 'nitrogen.budget', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE., narea )
-            xfact1 = rfact2r * 12. / 1.e15 * ryyss    ! conversion molC/kt --> PgC/yr
-            xfact2 = 1.e+3 * rno3 * 14. / 1.e12 * ryyss   ! conversion molC/l/s ----> TgN/m3/yr
-            xfact3 = 1.e+3 * rfact2r * rno3   ! conversion molC/l/kt ----> molN/m3/s
             cltxt='time-step   Alkalinity        Nitrate        Phosphorus         Silicate           Iron'
             IF( lwp ) WRITE(numnut,*)  TRIM(cltxt)
@@ -517,17 +517,13 @@
       IF( iom_use( "tnfix" ) .OR.  ( ln_check_mass .AND. kt == nitend )  ) THEN
          znitrpottot  = glob_sum ( nitrpot(:,:,:) * nitrfix * cvol(:,:,:) )
-         CALL iom_put( "tnfix"  , znitrpottot * 1.e+3 * rno3 )  ! Global  nitrogen fixation molC/l  to molN/m3 
+         CALL iom_put( "tnfix"  , znitrpottot * xfact3 )  ! Global  nitrogen fixation molC/l  to molN/m3 
       ENDIF
       !
       IF( iom_use( "tdenit" ) .OR.  ( ln_check_mass .AND. kt == nitend )  ) THEN
-         zrdenittot   = glob_sum ( denitr(:,:,:) * rdenit * xnegtr(:,:,:) * cvol(:,:,:) )
-         CALL iom_put( "tdenit"  , zrdenittot * 1.e+3 * rno3 )  ! Total denitrification molC/l to molN/m3 
-      ENDIF
-      !
-      IF( iom_use( "Sdenit" ) .OR.  ( ln_check_mass .AND. kt == nitend )  ) THEN
-         zsdenittot   = glob_sum ( sdenit(:,:) * e1e2t(:,:) )
-         CALL iom_put( "Sdenit", sdenit(:,:) * xfact3 * tmask(:,:,1) )  ! Nitrate reduction in the sediments
-      ENDIF
-
+         zrdenittot = glob_sum ( denitr(:,:,:) * rdenit * xnegtr(:,:,:) * cvol(:,:,:) )
+         zsdenittot = glob_sum ( sdenit(:,:) * e1e2t(:,:) * tmask(:,:,1) )
+         CALL iom_put( "tdenit" , ( zrdenittot + zsdenittot ) * xfact3 )  ! Total denitrification molC/l to molN/m3 
+      ENDIF
+      !
       IF( ln_check_mass .AND. kt == nitend ) THEN   ! Compute the budget of NO3, ALK, Si, Fer
          t_atm_co2_flx  = t_atm_co2_flx / glob_sum( e1e2t(:,:) )
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/SED/sedco3.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/SED/sedco3.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/SED/sedco3.F90	(revision 8841)
@@ -75,6 +75,5 @@
 
       DO jk = 1, jpksed
-10001    CONTINUE
-         IF( itime <= 2 ) THEN
+         DO WHILE( itime <= 2 )
             lconv  = .FALSE.
             IF( itime > 0 ) THEN  
@@ -154,5 +153,4 @@
 !                     WRITE(numsed,*) '    with re-initialization of initial PH field '       
                      itime = 2
-                     GOTO 10001
                   ELSE
 !                     WRITE(numsed,*) ' convergence after iter =', jiter, ' iterations ;  res =',zresm 
@@ -165,5 +163,5 @@
 !                     &               '  after iter =', jiter, ' iterations ;  res =',zresm  
 !                  WRITE(numsed,*) ' '
-                  itime = 0
+                  itime = 3
                ENDIF
             ELSE
@@ -172,5 +170,4 @@
                IF ( itime == 1 ) THEN
                   WRITE(numsed,*) ' try one more time with more iterations and higher relax. value'
-                  GOTO 10001
                ELSE IF ( itime == 2 ) THEN
                   WRITE(numsed,*) ' try one more time for with more iterations, higher relax. value'               
@@ -181,5 +178,5 @@
                ENDIF
             ENDIF
-         ENDIF
+         ENDDO ! End of WHILE LOOP
      ENDDO
 
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 8841)
@@ -97,4 +97,5 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xfracal    !: ??
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   nitrfac    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   nitrfac2   !: ??
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   orem       !: ??
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xdiss      !: ??
@@ -159,7 +160,7 @@
          !
          !*  SMS for the organic matter
-         ALLOCATE( xfracal (jpi,jpj,jpk), nitrfac(jpi,jpj,jpk) ,    &
-            &      orem    (jpi,jpj,jpk),                           &
-            &      prodcal(jpi,jpj,jpk),  xdiss   (jpi,jpj,jpk),    &
+         ALLOCATE( xfracal (jpi,jpj,jpk), orem(jpi,jpj,jpk)    ,    &
+            &      nitrfac(jpi,jpj,jpk), nitrfac2(jpi,jpj,jpk) ,    &
+            &      prodcal(jpi,jpj,jpk) , xdiss   (jpi,jpj,jpk),    &
             &      prodpoc(jpi,jpj,jpk) , conspoc(jpi,jpj,jpk) ,    &
             &      prodgoc(jpi,jpj,jpk) , consgoc(jpi,jpj,jpk) ,  STAT=ierr(4) )
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 8841)
@@ -44,4 +44,6 @@
    PUBLIC   trc_nxt          ! routine called by step.F90
 
+   REAL(wp) ::   rfact1, rfact2
+
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
@@ -104,14 +106,19 @@
       ENDIF
       !                                ! Leap-Frog + Asselin filter time stepping
-      IF( neuler == 0 .AND. kt == nittrc000 ) THEN    ! Euler time-stepping at first time-step (only swap)
+      IF( (neuler == 0 .AND. kt == nittrc000) .OR. ln_top_euler ) THEN    ! Euler time-stepping (only swap)
          DO jn = 1, jptra
             DO jk = 1, jpkm1
                trn(:,:,jk,jn) = tra(:,:,jk,jn)
+               trb(:,:,jk,jn) = trn(:,:,jk,jn)  
             END DO
          END DO
-      ELSE                                            ! Asselin filter + swap
-         IF( ln_linssh ) THEN   ;   CALL tra_nxt_fix( kt, nittrc000,         'TRC', trb, trn, tra, jptra )  !     linear ssh
-         ELSE                   ;   CALL tra_nxt_vvl( kt, nittrc000, rdttrc, 'TRC', trb, trn, tra,      &
-           &                                                                   sbc_trc, sbc_trc_b, jptra )  ! non-linear ssh
+      ELSE     
+         IF( .NOT. l_offline ) THEN ! Leap-Frog + Asselin filter time stepping
+            IF( ln_linssh ) THEN   ;   CALL tra_nxt_fix( kt, nittrc000,         'TRC', trb, trn, tra, jptra )  !     linear ssh
+            ELSE                   ;   CALL tra_nxt_vvl( kt, nittrc000, rdttrc, 'TRC', trb, trn, tra,      &
+              &                                                                   sbc_trc, sbc_trc_b, jptra )  ! non-linear ssh
+            ENDIF
+         ELSE
+                                       CALL trc_nxt_off( kt )       ! offline 
          ENDIF
          !
@@ -143,4 +150,82 @@
       !
    END SUBROUTINE trc_nxt
+
+
+   SUBROUTINE trc_nxt_off( kt )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE tra_nxt_vvl  ***
+      !!
+      !! ** Purpose :   Time varying volume: apply the Asselin time filter  
+      !!                and swap the tracer fields.
+      !! 
+      !! ** Method  : - Apply a thickness weighted Asselin time filter on now fields.
+      !!              - save in (ta,sa) a thickness weighted average over the three 
+      !!             time levels which will be used to compute rdn and thus the semi-
+      !!             implicit hydrostatic pressure gradient (ln_dynhpg_imp = T)
+      !!              - swap tracer fields to prepare the next time_step.
+      !!                This can be summurized for tempearture as:
+      !!             ztm = ( e3t_n*tn + rbcp*[ e3t_b*tb - 2 e3t_n*tn + e3t_a*ta ] )   ln_dynhpg_imp = T
+      !!                  /( e3t_n    + rbcp*[ e3t_b    - 2 e3t_n    + e3t_a    ] )   
+      !!             ztm = 0                                                       otherwise
+      !!             tb  = ( e3t_n*tn + atfp*[ e3t_b*tb - 2 e3t_n*tn + e3t_a*ta ] )
+      !!                  /( e3t_n    + atfp*[ e3t_b    - 2 e3t_n    + e3t_a    ] )
+      !!             tn  = ta 
+      !!             ta  = zt        (NB: reset to 0 after eos_bn2 call)
+      !!
+      !! ** Action  : - (tb,sb) and (tn,sn) ready for the next time step
+      !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
+      !!----------------------------------------------------------------------
+      INTEGER , INTENT(in   )   ::  kt       ! ocean time-step index
+      !!     
+      INTEGER  ::   ji, jj, jk, jn              ! dummy loop indices
+      REAL(wp) ::   ztc_a , ztc_n , ztc_b , ztc_f , ztc_d    ! local scalar
+      REAL(wp) ::   ze3t_b, ze3t_n, ze3t_a, ze3t_f, ze3t_d   !   -      -
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nittrc000 )  THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'trc_nxt_off : time stepping'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+         IF( .NOT. ln_linssh ) THEN
+            rfact1 = atfp * rdttrc
+            rfact2 = rfact1 / rau0
+         ENDIF
+        !  
+      ENDIF
+      !
+      DO jn = 1, jptra      
+         DO jk = 1, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ze3t_b = e3t_b(ji,jj,jk)
+                  ze3t_n = e3t_n(ji,jj,jk)
+                  ze3t_a = e3t_a(ji,jj,jk)
+                  !                                         ! tracer content at Before, now and after
+                  ztc_b  = trb(ji,jj,jk,jn) * ze3t_b
+                  ztc_n  = trn(ji,jj,jk,jn) * ze3t_n
+                  ztc_a  = tra(ji,jj,jk,jn) * ze3t_a
+                  !
+                  ze3t_d = ze3t_a - 2. * ze3t_n + ze3t_b
+                  ztc_d  = ztc_a  - 2. * ztc_n  + ztc_b
+                  !
+                  ze3t_f = ze3t_n + atfp * ze3t_d
+                  ztc_f  = ztc_n  + atfp * ztc_d
+                  !
+                  IF( .NOT. ln_linssh .AND. jk == mikt(ji,jj) ) THEN           ! first level 
+                     ze3t_f = ze3t_f - rfact2 * ( emp_b(ji,jj)      - emp(ji,jj)   ) 
+                     ztc_f  = ztc_f  - rfact1 * ( sbc_trc(ji,jj,jn) - sbc_trc_b(ji,jj,jn) )
+                  ENDIF
+
+                  ze3t_f = 1.e0 / ze3t_f
+                  trb(ji,jj,jk,jn) = ztc_f * ze3t_f       ! ptb <-- ptn filtered
+                  trn(ji,jj,jk,jn) = tra(ji,jj,jk,jn)     ! ptn <-- pta
+                  !
+               END DO
+            END DO
+         END DO
+         ! 
+      END DO
+      !
+   END SUBROUTINE trc_nxt_off
 
 #else
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 8841)
@@ -7,9 +7,4 @@
    !!             2.0  !  2007-12 (C. Ethe, G. Madec)  rewritting
    !!----------------------------------------------------------------------
-#if defined key_top
-   !!----------------------------------------------------------------------
-   !!   'key_top'                                                TOP models
-   !!----------------------------------------------------------------------
-   !
    !                                            !* Domain size *
    USE par_oce , ONLY :   jpi      =>   jpi        !: first  dimension of grid --> i 
@@ -117,14 +112,3 @@
    USE zdfmxl , ONLY :   hmlpt       =>   hmlpt       !: mixed layer depth at t-points (m)
 
-#else
-   !!----------------------------------------------------------------------
-   !!  Empty module :                                     No passive tracer
-   !!----------------------------------------------------------------------
-#endif
-
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!======================================================================
 END MODULE oce_trc
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 8841)
@@ -6,8 +6,4 @@
    !! History :    -   !  2005-07  (C. Talandier) original code for OPA
    !!             1.0  !  2005-10  (C. Ethe     ) adapted to passive tracer
-   !!----------------------------------------------------------------------
-#if defined key_top
-   !!----------------------------------------------------------------------
-   !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
    !!   prt_ctl_trc      :   control print in mpp for passive tracers
@@ -299,14 +295,3 @@
    END SUBROUTINE prt_ctl_trc_init
 
-#else
-   !!----------------------------------------------------------------------
-   !!   Dummy module :                                    NO passive tracer
-   !!----------------------------------------------------------------------
-#endif
- 
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!======================================================================   
 END MODULE prtctl_trc
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 8841)
@@ -8,11 +8,7 @@
    !!   NEMO      1.0  !  2004-03  (C. Ethe)  Free form and module
    !!----------------------------------------------------------------------
-#if defined key_top
-   !!----------------------------------------------------------------------
-   !!   'key_top'                                                TOP models
-   !!----------------------------------------------------------------------
    USE par_oce
    USE par_trc
-   USE bdy_oce, only: ln_bdy, nb_bdy, OBC_DATA
+   USE bdy_oce, only: jp_bdy, ln_bdy, nb_bdy, OBC_DATA
    
    IMPLICIT NONE
@@ -173,11 +169,11 @@
 # endif
    !
-   CHARACTER(len=20), PUBLIC, ALLOCATABLE,  SAVE,  DIMENSION(:)   ::  cn_trc_dflt          ! Default OBC condition for all tracers
-   CHARACTER(len=20), PUBLIC, ALLOCATABLE,  SAVE,  DIMENSION(:)   ::  cn_trc               ! Choice of boundary condition for tracers
-   INTEGER,           PUBLIC, ALLOCATABLE,  SAVE,  DIMENSION(:)   ::  nn_trcdmp_bdy        !: =T Tracer damping
+   CHARACTER(len=20), PUBLIC, DIMENSION(jp_bdy) :: cn_trc_dflt   ! Default OBC condition for all tracers
+   CHARACTER(len=20), PUBLIC, DIMENSION(jp_bdy) :: cn_trc        ! Choice of boundary condition for tracers
+   INTEGER,           PUBLIC, DIMENSION(jp_bdy) :: nn_trcdmp_bdy !: =T Tracer damping
+!$AGRIF_DO_NOT_TREAT
    ! External data structure of BDY for TOP. Available elements: cn_obc, ll_trc, trcnow, dmp
    TYPE(OBC_DATA),    PUBLIC, ALLOCATABLE, DIMENSION(:,:), TARGET ::  trcdta_bdy           !: bdy external data (local process)
-   !
-
+!$AGRIF_END_DO_NOT_TREAT
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3.1 , NEMO Consortium (2010)
@@ -210,7 +206,5 @@
       !
       IF ( ln_bdy ) THEN
-         ALLOCATE( cn_trc_dflt(nb_bdy)   , cn_trc(nb_bdy)     , nn_trcdmp_bdy(nb_bdy) ,       &
-         &      trcdta_bdy(jptra,nb_bdy)                                              ,       &
-         &      STAT = ierr(2)  )
+         ALLOCATE( trcdta_bdy(jptra, jp_bdy), STAT = ierr(2) )
       ENDIF
       !
@@ -224,10 +218,4 @@
    END FUNCTION trc_alloc
 
-#else
-   !!----------------------------------------------------------------------
-   !!  Empty module :                                     No passive tracer
-   !!----------------------------------------------------------------------
-#endif
-
    !!======================================================================
 END MODULE trc
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 8841)
@@ -227,10 +227,10 @@
                      ik = mbkt(ji,jj) 
                      IF( ik > 1 ) THEN
-                        zl = ( gdept_1d(ik) - gdept_n(ji,jj,ik) ) / ( gdept_1d(ik) - gdept_1d(ik-1) )
+                        zl = ( gdept_1d(ik) - gdept_0(ji,jj,ik) ) / ( gdept_1d(ik) - gdept_1d(ik-1) )
                         ptrcdta(ji,jj,ik) = (1.-zl) * ptrcdta(ji,jj,ik) + zl * ptrcdta(ji,jj,ik-1)
                      ENDIF
                      ik = mikt(ji,jj)
                      IF( ik > 1 ) THEN
-                        zl = ( gdept_n(ji,jj,ik) - gdept_1d(ik) ) / ( gdept_1d(ik+1) - gdept_1d(ik) )
+                        zl = ( gdept_0(ji,jj,ik) - gdept_1d(ik) ) / ( gdept_1d(ik+1) - gdept_1d(ik) )
                         ptrcdta(ji,jj,ik) = (1.-zl) * ptrcdta(ji,jj,ik) + zl * ptrcdta(ji,jj,ik+1)
                      ENDIF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 8841)
@@ -69,5 +69,4 @@
       !
       CALL trc_ini_sms   ! SMS
-      CALL trc_ini_inv   ! Inventories
       CALL trc_ini_trp   ! passive tracers transport
       CALL trc_ice_ini   ! Tracers in sea ice
@@ -78,4 +77,6 @@
       IF( nn_dttrc /= 1 ) &
       CALL trc_sub_ini    ! Initialize variables for substepping passive tracers
+      !
+      CALL trc_ini_inv   ! Inventories
       !
       IF( nn_timing == 1 )   CALL timing_stop('trc_init')
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ALTIX_NAUTILUS_MPT
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ALTIX_NAUTILUS_MPT	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ALTIX_NAUTILUS_MPT	(revision 8841)
@@ -65,4 +65,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV	(revision 8841)
@@ -47,4 +47,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_CALYPSO
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_CALYPSO	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW6_CALYPSO	(revision 8841)
@@ -43,4 +43,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_METO
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_METO	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_METO	(revision 8841)
@@ -48,4 +48,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_MONSOON
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_MONSOON	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-PW7_MONSOON	(revision 8841)
@@ -47,4 +47,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA	(revision 8841)
@@ -11,5 +11,5 @@
 # @ total_tasks = NPROCS
 # time
-# @ wall_clock_limit = 1:30:00
+# @ wall_clock_limit = 00:59:00
 # @ queue
 
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_DEBUG
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_DEBUG	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_DEBUG	(revision 8841)
@@ -11,5 +11,5 @@
 # @ total_tasks = NPROCS
 # time
-# @ wall_clock_limit = 1:30:00
+# @ wall_clock_limit = 00:59:00
 # @ queue
 
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_O0
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_O0	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_ADA_O0	(revision 8841)
@@ -11,5 +11,5 @@
 # @ total_tasks = NPROCS
 # time
-# @ wall_clock_limit = 1:30:00
+# @ wall_clock_limit = 00:59:00
 # @ queue
 
@@ -45,4 +45,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_CURIE
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_CURIE	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_CURIE	(revision 8841)
@@ -45,4 +45,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_MOBILIS
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_MOBILIS	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-X64_MOBILIS	(revision 8841)
@@ -42,4 +42,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC40_METO
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC40_METO	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC40_METO	(revision 8841)
@@ -40,4 +40,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
